// Copyright 2014 zks
//

package socketutils

import (
	"fmt"
	//"strings"
	"os"

	"github.com/Unknwon/com"
	"github.com/Unknwon/goconfig"
)

var Cfg *goconfig.ConfigFile

// LoadConfig loads configuration file.
func LoadConfig(cfgPath string) {
	if !com.IsExist(cfgPath) {
		os.Create(cfgPath)
	}

	var err error
	Cfg, err = goconfig.LoadConfigFile(cfgPath)
	if err == nil {
		Informational("Initialize app.ini")
	} else {
		fmt.Println(err)
		os.Exit(2)
	}

}

// SaveConfig saves configuration file.
func SaveConfig(cfgPath string) error {
	return goconfig.SaveConfigFile(Cfg, cfgPath)
}

func LogError(err error) {
	if err != nil {
		Critical(err.Error())
	}
}
